<?php

// QuickTicket 2.0 build:20090203

if ( !defined('QTI_HTML_DTD') ) define ('QTI_HTML_DTD', '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">');
if ( !defined('QTI_HTML_CHAR') ) define ('QTI_HTML_CHAR', 'iso-8859-1');
if ( !defined('QTI_HTML_DIR') ) define ('QTI_HTML_DIR', 'ltr');
if ( !defined('QTI_HTML_LANG') ) define ('QTI_HTML_LANG', 'fr');

// It is recommended to always use capital on first letter in the translation, script changes to lower case if necessary.
// The character doublequote ["] is FORBIDDEN (reserved for html tags)
// To make a single quote use slashe [\']

// -------------
// TOP LEVEL VOCABULARY
// -------------

// Use the top level vocabulary to give the most appropriate name
// for the topics (object items) managed by this application.
// e.g. Ticket, Incident, Subject, Thread, Request, Faq,...

$L['Topic']='Ticket';
$L['Topics']='Tickets';
$L['topic']=strtolower($L['Topic']);
$L['topics']=strtolower($L['Topics']);

// The top level words are re-used in a lot of translations defined here after

$L['Y']='Oui';
$L['N']='Non';
$L['Ok']='Ok';

// Specific vocabulary

$L['Domain']='Domaine';
  $L['Domains']='Domaines';
$L['Section']='Section';
  $L['Sections']='Sections';
$L['Topic_add']='Nouveau ticket';
  $L['Topic_del']='Effacer le ticket';
  $L['Topic_upd']='Modifier le ticket';
$L['User']='Utilisateur';
  $L['Users']='Utilisateurs';
  $L['User_add']='Nouvel utilisateur';
  $L['User_del']='Effacer l\'utilisateur';
  $L['User_upd']='Editer le profil';
$L['Status']='Statut';
  $L['Statuss']='Statuts';
  $L['Status_add']='Nouveau status';
  $L['Status_del']='Effacer le statut';
  $L['Status_upd']='Modifier le statut';
$L['Message']='Message';
  $L['Messages']='Messages';
  $L['Message_deleted']='Message effac&eacute;...';
$L['Forward']='Transfers';
  $L['Forwards']='Transfers';
$L['First_message']='Premier&nbsp;message';
$L['Last_message']='Dernier message';
$L['Reply']='Reponse';
$L['Replys']='Reponses';
$L['Attachment']='Document';
$L['Notify_also']='Notifier aussi';
$L['Drop_attachment']='Effacer&nbsp;le&nbsp;document';
$L['Wisheddate']='Date demand&eacute;e';
$L['H_Wisheddate']='(aaaa-mm-jj) date de livraison souhait&eacute;e';
$L['News']='News';
$L['Newss']='News'; // In other languages: News=One news, Newss=Several news
$L['News_stamp']='News: ';
$L['Ref']='Ref.';
$L['Title']='Titre';
$L['Smiley']='Pr&eacute;fixe icone';
$L['Notification']='Notification';
$L['Username']='Nom d\'utilisateur';
  $L['Userrole']['A']='Administrateur'; $L['Userroles']['A']='Administrateurs';
  $L['Userrole']['M']='Staff';          $L['Userroles']['M']='Staffs';
  $L['Userrole']['U']='Membre';         $L['Userroles']['U']='Membres';
  $L['Userrole']['V']='Visiteur';       $L['Userroles']['V']='Visiteurs';
  $L['Userrole_MF']='M&eacute;diateur de section';
  $L['Userrole_MA']='Acteur';
  $L['Userrole_UN']='Utilisateur notifi&eacute;';
$L['Joined']='Depuis';
$L['Avatar']='Photo';
$L['Signature']='Signature';
$L['Role']='R&ocirc;le';
$L['Topic_starter']='Auteur';
$L['Modified_by']='Modifi&eacute; par';
$L['Deleted_by']='Effac&eacute; par';
$L['Top_participants']='Top participants';
$L['Password']='Mot de passe';

// Common

$L['Add']='Ajouter';
$L['Advanced_reply']='Pr&eacute;visualisation...';
$L['All']='Tous';
$L['By']='Par';
$L['Change']='Changer';
$L['Change_status']='Changer le statut...';
$L['Change_type']='Changer le type...';
$L['Close']='Fermer';
$L['Closed']='Ferm&eacute;';
$L['Containing']='Contenant';
$L['Date']='Date';
$L['Dates']='Dates';
$L['Day']='Jour';
$L['Days']='Jours';
$L['Destination']='Destination';
$L['Details']='D&eacute;tails';
$L['Display_at']='Afficher &agrave; la date';
$L['Email']='E-mail'; $L['No_Email']='Pad d\'e-mail';
$L['Exit']='Exit';
$L['First']='Premi&egrave;re';
$L['Goodbye']='Vous &ecirc;tes d&eacute;connect&eacute;... Au revoir';
$L['Goto']='Allez';
$L['H_Website']='Url avec http://';
$L['Help']='Aide';
$L['Hidden']='Cach&eacute;';
$L['I_wrote']='J\'ai &eacute;crit';
$L['Information']='Information';
$L['Items_per_month']='Tickets par mois';
$L['Items_per_month_cumul']='Cumul des tickets par mois';
$L['Last']='Derni&egrave;re';
$L['Legend']='L&eacute;gende';
$L['Location']='Localisation';
$L['Maximum']='Maximum';
$L['Minimum']='Minimum';
$L['Month']='Mois';
$L['Next']='Suivante';
$L['None']='Aucun';
$L['Options']='Options';
$L['Page']='page';
$L['Pages']='pages';
$L['Phone']='T&eacute;l&eacute;phone';
$L['Preview']='Pr&eacute;visualisation';
$L['Previous']='Pr&eacute;c&eacute;dente';
$L['Reason']='Raison';
$L['Remove']='Enlever';
$L['Result']='R&eacute;sultat';
$L['Results']='R&eacute;sultats';
$L['Save']='Sauver';
$L['Seconds']='Secondes';
$L['Selected_from']='s&eacute;lectionn&eacute;s sur';
$L['Send']='Envoyer';
$L['Send_on_behalf']='Au nom de';
$L['Statistics']='Statistiques';
$L['Tag']='Cat&eacute;gorie';
$L['Tags']='Cat&eacute;gories';
$L['Time']='Heure';
$L['Total']='Total';
$L['Type']='Type';
$L['Website']='Site web'; $L['No_Website']='Aucun site web';
$L['Welcome']='Bienvenue';
$L['Welcome_to']='Bienvenue &agrave; un nouveau membre, ';
$L['Year']='Ann&eacute;e';

// Menu

$L['FAQ']='FAQ';
$L['Search']='Chercher';
$L['Memberlist']='Membres';
$L['Login']='Connexion';
$L['Logout']='D&eacute;connexion';
$L['Register']='S\'enregistrer';
$L['Profile']='Profil';
$L['Administration']='Administration';
$L['Privacy']='Mentions&nbsp;l&eacute;gales';
$L['Coppa_form']='Formulaire&nbsp;Coppa';

// Section // use &nbsp; to avoid double ligne buttons

$L['Post_new_topic']='Nouveau&nbsp;ticket';
$L['Post_reply']='R&eacute;pondre';
$L['Topic_closed']='Ticket&nbsp;ferm&eacute;';
$L['Goto_message']='[<b>&raquo;</b>]';
$L['H_Goto_message']='Voir le dernier message';

$L['My_last_topic']='Mon&nbsp;dernier&nbsp;ticket';
$L['All_my_topics']='Tous&nbsp;mes&nbsp;tickets';
$L['All_my_assigned']='Tickets&nbsp;assign&eacute;s';
$L['Topic_handled']='Ticket g&eacute;r&eacute;';
$L['Topics_handled']='Tickets g&eacute;r&eacute;s';
$L['Topic_forwarded']='Ticket a &eacute;t&eacute; pris en charge par %s.';

$L['You_reply']='J\'ai r&eacute;pondu';
$L['Quote']='Citer';
$L['Edit']='Editer';
$L['Delete']='Effacer';
$L['Move']='D&eacute;placer';
$L['Move_to']='D&eacute;placer vers';
$L['Change_actor']='Changer d\'acteur';
$L['Close_my_topic']='Je ferme mon ticket';

$L['Quick_reply']='Reponse rapide';
$L['Close_topic']='Fermer le ticket';
$L['Previous_replies']='Pr&eacute;c&eacute;dentes r&eacute;ponses';
$L['Edit_message']='Editer le message';
$L['Delete_message']='Effacer le message';

$L['Move_keep']='Conserver la r&eacute;f&eacute;rence originale';
$L['Move_reset']='Remettre la r&eacute;f&eacute;rence &agrave; z&eacute;ro';
$L['Move_follow']='Renum&eacute;rot&eacute; (suivant la section de destination)';

$L['Topic_closed_show']='Montrer les tickets ferm&eacute;s';
$L['Topic_closed_hide']='Masquer les tickets ferm&eacute;s';
$L['Topic_news_show']='Montrer les news';
$L['Topic_news_hide']='Masquer les news';
$L['Topic_show_all']='Montrer toutes les sections';
$L['Topic_show_this']='Montrer cette section uniquement';
$L['Last_column']='Extra colonne';
$L['Last_column_label']['replies']=$L['Replys'];
$L['Last_column_label']['views']='Vues';
$L['Last_column_label']['wisheddate']=$L['Wisheddate'];
$L['Last_column_label']['status']=$L['Status'];
$L['Last_column_label']['id']='Id';
$L['Last_column_label']['actorname']=$L['Userrole_MA'];
$L['Last_column_label']['notifiedname']=$L['Userrole_UN'];
$L['Last_column_label']['tags']=$L['Tags'];

// Stats

$L['General_site']='Site en g&eacute;neral';
$L['Board_start_date']='Mise en service';

// Search

$L['Recent_messages']='Messages&nbsp;r&eacute;cents';
$L['All_news']='Toutes&nbsp;les&nbsp;news';
$L['All_my_topics']='Tous&nbsp;mes&nbsp;tickets';

$L['Advanced_search']='Recherche avanc&eacute;e';
$L['H_Advanced']='(entrez un num&eacute;ro de '.$L['topic'].' ou un mot cl&eacute;)';
$L['Keywords']='Mot(s) cl&eacute;';
$L['Search_option']='Option de recherche';
$L['Search_criteria']='Crit&egrave;re de recherche';
$L['Search_by_key']='Chercher par mot(s) cl&eacute;';
$L['Search_by_ref']='Chercher par num&eacute;ro';
$L['Search_by_status']='Chercher par statut';
$L['Search_result']='R&eacute;sultat de la recherche';
$L['In_title_only']='Dans le titre uniquement';
$L['In_all_sections']='Dans toutes sections';
$L['Any_time']='Toute date';
$L['Any_status']='Tout statut';
$L['At_least_0']='Avec ou sans r&eacute;ponse';
$L['At_least_1']='Au moins 1 r&eacute;ponse';
$L['At_least_2']='Au moins 2 r&eacute;ponses';
$L['At_least_3']='Au moins 3 r&eacute;ponses';
$L['H_Reference']='(entrez seulement la partie num&eacute;rique)';
$L['Too_many_keys']='Trop de mots cl&eacute;s';
$L['Search_by_words']='Chercher chaque mot s&eacute;par&eacute;ment';
$L['Search_exact_words']='Chercher les mots ensemble';
$L['Search_by_date']='Chercher par date';
$L['This_week']='Cette semaine';
$L['This_month']='Ce mois';
$L['This_year']='Cette ann&eacute;e';
$L['With_tag']= 'Cat&eacute;gorie';
$L['Show_only_tag']='Afficher seulement ceux de la cat&eacute;gorie';
$L['Tag_only']='uniquement de cat&eacute;gorie'; // must be in lowercase
$L['H_Tag_input']='Vous pouvez indiquer plusieurs cat&eacute;gories s&eacute;par&eacute;es par un point-virgule (ex.: c1;c2 recherche les tickets de cat&eacute;gorie "c1" ou "c2"). Laissez le champ vide pour ne pas tenir compte des cat&eacute;gories.';

// Restrictions

$L['R_member']='Acc&egrave;s r&eacute;serv&eacute; aux seuls membres.<br/><br/>Veuillez vous connecter pour pouvoir continuer. Pour devenir membre, utilisez le menu s\'enregistrer.<br/><br/><a href="qti_index.php">Exit</a>';
$L['R_staff']='Acc&egrave;s r&eacute;serv&eacute; aux seuls membres du staff. <a href="qti_index.php">Exit</a>';
$L['R_security']='Les param&egrave;tres de s&eacute;curit&eacute;s ne permettent pas d\'utiliser cette fonction.';

// Errors

$L['E_access']='Acc&egrave;s refus&eacute;...';
$L['E_already_used']='D&eacute;j&agrave; utilis&eacute;';
$L['E_char_max']='(maximum %d caracteres)';
$L['E_editing']='Des donn&eacute;es sont modifi&eacute;es. Quitter sans sauver?';
$L['E_file_size']='Fichier trop gros';
$L['E_invalid']='erron&eacute;';
$L['E_javamail']='Protection: activez java pour voir les adresses e-mail';
$L['E_line_max']='(maximum %d lignes)';
$L['E_mandatory']='Un champ obligatoire est vide';
$L['E_missing_http']='l\'url doit commencer par \'http://\' ou \'https://\'';
$L['E_no_desc']='Aucune description';
$L['E_no_public_section']='Le site ne contient pas de section publique. Pour acc&eacute;der aux sections priv&eacute;s, vous devez vous identifier.';
$L['E_no_result']='Aucun r&eacute;sultat';
$L['E_no_title']='Veuillez donner un titre &agrave; ce nouveau sujet';
$L['E_no_visible_section']='Le site ne contient pas de section visible pour vous.';
$L['E_ref_search']='D&eacute;cimale (ou virgule) non accept&eacute;e comme num&eacute;ro de r&eacute;f&eacute;rence. Utilisez des guillemets pour chercher un nombre en tant que text.';
$L['E_section_closed']='Section&nbsp;ferm&eacute;e'; // use &nbsp; as space to avoid double ligne buttons
$L['E_text']='Probl&egrave;me avec votre texte.';
$L['E_too_long']='Message trop long';
$L['E_too_much']='Trop de messages aujourd\'hui...<br/><br/>Pour des raisons de s&eacute;curit&eacute;, le nombre de messages est limit&eacute;. Essayez &agrave; nouveau demain. Merci de votre compr&eacute;hension.';
$L['E_topic_private']='(ou les tickets sont priv&eacute;s)';
$L['E_wait']='Veuillez patienter quelques secondes...';

// Success

$L['S_update']='Changement effectu&eacute;...';
$L['S_delete']='Effacement effectu&eacute;...';
$L['S_insert']='Cr&eacute;ation termin&eacute;e...';
$L['S_save']='Sauvegarde r&eacute;ussie...';
$L['S_message_saved']='Message sauv&eacute;...<br/>Merci';

// Timezones

$L['dateMMM']=array(1=>'Janvier','F&eacute;vrier','Mars','Avril','Mai','Juin','Juillet','Ao&ucirc;t','Septembre','Octobre','Novembre','D&eacute;cembre');
$L['dateMM'] =array(1=>'Jan','Fev','Mar','Avr','Mai','Juin','Juil','Aout','Sept','Oct','Nov','Dec');
$L['dateM']  =array(1=>'J','F','M','A','M','J','J','A','S','O','N','D');
$L['dateDDD']=array(1=>'Lundi','Mardi','Mercredi','Jeudi','Vendredi','Samedi','Dimanche');
$L['dateDD'] =array(1=>'Mon','Tue','Wed','Thu','Fri','Sat','Sun');
$L['dateD']  =array(1=>'L','M','M','J','V','S','D');
$L['dateSQL']=array(
  'January'  => 'Janvier',
  'February' => 'F&eacute;vrier',
  'March'    => 'Mars',
  'April'    => 'Avril',
  'May'      => 'Mai',
  'June'     => 'Juin',
  'July'     => 'Juillet',
  'August'   => 'Ao&ucirc;t',
  'September'=> 'Septembre',
  'October'  => 'Octobre',
  'November' => 'Novembre',
  'December' => 'D&eacute;cembre',
  'Monday'   => 'Lundi',
  'Tuesday'  => 'Mardi',
  'Wednesday'=> 'Mercredi',
  'Thursday' => 'Jeudi',
  'Friday'   => 'Vendredi',
  'Saturday' => 'Samedi',
  'Sunday'   => 'Dimanche',
  'Today'=>'Aujourd\'hui',
  'Yesterday'=>'Hier',
  'Jan'=>'Jan',
  'Feb'=>'F&eacute;v',
  'Mar'=>'Mars',
  'Apr'=>'Avr',
  'May'=>'Mai',
  'Jun'=>'Jun',
  'Jul'=>'Jul',
  'Aug'=>'Ao&ucirc;t',
  'Sep'=>'Sept',
  'Oct'=>'Oct',
  'Nov'=>'Nov',
  'Dec'=>'D&eacute;c',
  'Mon'=>'Lu',
  'Tue'=>'Ma',
  'Wed'=>'Me',
  'Thu'=>'Je',
  'Fri'=>'Ve',
  'Sat'=>'Sa',
  'Sun'=>'Di');

?>